clear
close all
clc

% definisemo anonimnu funkciju x.^2
sqr = @(x) x.^2;
% pravimo podelu intervala
x = linspace(-20, 20, 2000);
% i izracunamo vrednosti funkcije u tackama podele
% vrednost anonimne funkcije u tacki se racuna pomocu funkcije feval
sqr_x = feval(sqr, x);

% na grafiku crtamo funkciju
figure(1)
hold on
plot(x, sqr_x, 'b')
legend('sqr')
grid

% racunamo integral anonimne funkcije na intervalu 0,2
% u starijim verzijama matlaba koristi se funkcija quad
int = integral(sqr, 0, 2);
disp('Integral funkcije je: ')
disp(int);

% racunamo integral nove anonimne funkcije na intervalu 0,pi
% u starijim verzijama matlaba koristi se funkcija quad
int = integral(@(x) 2*sin(x), 0, pi);
disp('Integral 2*sin(x) na [0,pi] je');
disp(int);

% definisemo koeficijente polinoma
a = 1.3;
b = -2;
c = 10;
% definisemo polinom sa zadatim koeficijentima
parabola = @(x) a*x.^2 + b*x + c;
% pravimo novu podelu intervala
xx = linspace(-20, 20, 1000);

% crtamo polinom
plot(xx, feval(parabola, xx), 'r')
legend('sqr','parabola')
grid

% parametarski integral po c definisan sa anonimnom funkcijom
% NAPOMENA: moguce je da ovo ne radi sa quad funkcijom u starijim verizjama matlaba
g = @(c) (integral(@(x)(x.^2 + c*x + 1), 0, 1));
disp('Vrednost integrala je ');
disp(g(2))

% definisemo anonimnu funkciju koja ima dva parametra
logcx = @(n,x) (20*sin((x.^n + 1)./(x.^2 - 1)));
% pravimo novu podelu intervala
xxx = linspace(-20, 20, 2000);
% vrednost anonimne funkcie moze da se racuna i direktnom zamenom
% argumenata
ylogcx =logcx(3, xxx);

% crtamo dobijene vrednosti
plot(xxx, ylogcx, 'g')
legend('sqr', 'parabola', 'log')
grid

hold off

