% pravimo proizvoljnu podelu intervala
x = 10:5:50;
% izracunvamo vrednost funkcije na podeli x
y = log(x);

% izracunavamo polinom stepena 2 koji aproksimira funkciju
P2 = polyfit(x, y, 2);
% izracunavamo polinom stepena 3 koji aproksimira funkciju
P3 = polyfit(x, y, 3);

% pravimo novu i finiju podelu intervala
xx = linspace(10,50, 1000);
% racunamo teorijske vrednosti funkcije na podeli xx
fx = log(xx);
% racunamo vrednosti polinoma drugog stepena kojim aproksimiramo funkciju
p2x = polyval(P2, xx);
% racunamo vrednosti polinoma treceg stepena kojim aproksimiramo funkciju
p3x = polyval(P3, xx);

% crtamo dobijene rezultate
figure(1)
plot(xx, fx, xx, p2x, xx, p3x)
grid
legend('log(x)', 'Poly 2', 'Poly 3');