% pravimo proizvoljnu podelu intervala
x = -5:1:5;
% izracunvamo vrednost Rungeove funkcije na podeli x
y = 1./(1 + 25.*x.^2);

% izracunavamo polinom stepena 2 koji aproksimira funkciju
p2x = polyfit(x, y, 2);
% izracunavamo polinom stepena 2 koji aproksimira funkciju
p3x = polyfit(x, y, 3);
% vektor cebisevljevih cvorova je inicijalno prazan
xc = [];
% donja granica intervala
a = -5;
% gornja granica intervala
b = 5;
% ukupan broj tacaka podele
n = 11;
% u petlji racunamo cebisevljeve cvorove
for (i = 1:1:n)
   % bukvalno prepisemo izraz iz zadataka
   xx = (a+b)/2 + (b-a)/2*cos((n - i + 0.5)/n*pi);
   % dobijeni cvor nadovezemo na xc
   xc = [xc xx];
end

% racunamo vrednosti funkcije u cebisevljevim cvorovima
yc = 1./(1 + 25.*xc.^2);

% izracunavamo polinom stepena 2 koji aproksimira funkciju na cebisevljevoj podeli
p2c = polyfit(xc, yc, 2);
% izracunavamo polinom stepena 3 koji aproksimira funkciju na cebisevljevoj podeli
p3c = polyfit(xc, yc, 3);

% pravimo mnogo finiju podelu intervala
xx1 = linspace(-5,5,1000);
% izracunavamo vrednost Rungeove funkcije na podeli xx1
fx = 1./(1 + 25.*xx1.^2);

% graficki prikazujemo dobijene rezultate
figure(1)
plot(xx1, fx, xx1, polyval(p2x, xx1), xx1, polyval(p3x, xx1),xx1, polyval(p2c, xx1), xx1, polyval(p3c, xx1))
legend('fx', 'p2x', 'p3x', 'p2c', 'p3c')
grid
