% definisemo matricu sistema
A = [3 4 -2 2; 4 9 -3 5; 1 4 6 7];
% definisemo vektor kolonu
b = [2; 8; 10; 2];

% zarad lakseg racunanja pravimo prosirenu matricu sistema tako sto
% nadovezemo slobodni vektor kolonu b na matricu A
a = [A b];

% resavamo sistem pomocu matlab ugradjene funkcije da bismo mogli da
% uporedimo sa svojim resenjima
xt = A\b;

% izracunavamo velicinu sistema
[m,n] = size(a); % m - vrste, n - kolone

% u petlji pravimo dijagonalnu matricu
for j = 1:m-1
    % pivotiranje
    % u slucaju da je element na dijagonali nula, vrsimo zamenu vrsta
    % sve dok na dijagonalno mesto ne dovedemo element razlicit od nula
    for z = 2:m
        if a(j,j) == 0
            t = a(j,:);
            a(j,:) = a(z, :);
            a(z,:) = t;
        end
    end
    % ponistavanje elementa ispod dijagonale
    for i = j+1:m
       a(i, :) = a(i,:) - a(j,:)*(a(i,j)/a(j,j)); 
    end
end

% vektor resenja ja na pocetku nula
x = zeros(1,m);

% Gaus zordanova metoda matricu sistema pretvara u dijagonalnu, pa treba
% ponistiti i elemente iznad glavne dijagonale

% ponistavamo elemente iznad glavne dijagonale i izracunavamo xs
for s = 1:m
    % ponistavanje elemenata iznad dijagonale
    a(s,:) = a(s,:)/a(s,s);
    % izracunavanje resenja
    x(s) = a(s,n);
end

% stampamo dobijena resenja
x'
xt