clear
close all
clc

set(0,'DefaultAxesXGrid','on','DefaultAxesYGrid','on')

% 1.  neprekidno diferencijabilna na intervalu
% 2. razlicit znak na krajevima intervala
% 3. za svako x iz intervala postoji f''(x)
% 4. na intervalu prvi i drugi izvod ne menjaju znak, i prvi izvod nikad nije
% nula
% 5. x0 takva da je f(x)f''(x0) > 0
% xn = xp - f(xp)/fp(xp);

% definisemo funkciju
f = @(x) x.^3 - cos(x);
% peske racunamo izvod funkcije
fp = @(x) 3*x.^2 + sin(x);

% racunamo podelu intervala
xx = linspace(-2.1, 2.1, 1000);
% facunamo vrednosti funkcije na podeli
fx = feval(f, xx);

% zadajemo tacnost koju zelimo
eps = 1e-6;

% crtamo grafik
figure(1)
hold on
% ucrtavamo funkciju
plot(xx, fx, 'g')
% ucrtavamo x osu
plot([-2.1 2.1], [0 0], 'k')


% naivno zadajemo pocetno i prethdno resenje
xp = 2;
xn = 2 - 2*eps;

% crtamo pocetnu tacku
plot(xp, feval(f,xp), 'ro');

% dok god ne postignemo odgovarajucu tacnost
while abs((xp - xn)/xn) > eps
   
    xp = xn;
    xn = xn - feval(f, xn)/feval(fp, xn);
    
    % ucrtavamo novu tacku na grafiku
    plot(xn, 0, 'bo')
    % ucrtavamo vrednost funkcije u novoj tacki
    plot(xn, feval(f,xn), 'ro');
    
    % ucrtavamo tangentu
    plot([xp xn],[feval(f, xp) 0],'b');
    % crtamo liniju do nove vrednosti funkcije
    plot([xn xn], [0 feval(f, xn)], 'r');
    
    % postavljamo naslov
    title(['x = ' num2str(xn)]);
    
    % pauziramo izvrsavanje
    pause(0.5)
end

hold off

% stampamo izracunatu nulu
disp(xn);