close all
clear
clc

% ovom naredbom se ukljucuje grid za sve vreme trajanja trenutne matlab
% sesije
set(0,'DefaultAxesXGrid','on','DefaultAxesYGrid','on')

% definisemo anonimnu funkciju ciju nulu trazimo
f = @(x) cos(x) - x.^3;
% pravimo podelu intervala na 1000 tacaka
x = linspace(-10, 10, 1000);

% crtamo rezultate
figure(1)
% brisemo sadrzaj forma
clf
% fiksiramo formu
hold on
% crtamo funkcije
plot(x, feval(f, x), 'g')
% crtamo x-osu
plot([-10 10], [0 0], 'k')

% naivno biramo pocetno resenje
x0 = 5;
% definisemo korak pocetni korak za pretragu intervala
dx = 0.1;
% definisemo levu i desnu granicu intervala
a = x0;
b = x0;
% definisemo trenutne i prethodne granice intervala
ap = a;
bp = a;
% definisemo tacnost koju zelimo da postignemo
eps = 1e-6;

% u petlji uvecavamo interval sve dok ne pronadjemo dva kraja u kojima su
% vrednosti funkcije suprtnog znaka
while feval(f,a)*feval(f,b) > 0  
    
    % pamtimo prethodne vrednosti
    ap = a;
    bp = b;
    
    % prosirujemo interval
    a = x0 - dx;
    b = x0 + dx;
    
    % ucrtacamo tacke na x osi
    plot([a b], [0 0], 'ro')
    % ucrtavamo tacke na funkciji
    plot([a b], [feval(f,a) feval(f,b)], 'ro')
    
    % uvecavamo interval za sledecu iteraciju
    dx = dx*2;
    
    % pauziramo izvrsavanje na 0.1 sekundu
    pause(0.1)
end

% pronadjene krajeve intervvala ucrtavamo drugom bojom
plot([a b], [0 0], 'bo')
plot([a b], [feval(f,a) feval(f,b)], 'bo')
% prekida fiksiranje figure
hold off

% na novoj figuri crtamo simulaciju polovljenja intervala
figure (2)
% fiksiramo formu
hold on
% crtamo funkciju
plot(x, feval(f, x), 'g')
% crtamo x osu
plot([-10 10], [0 0], 'k')

% crtamo granice intervala
plot([a b], [0 0], 'ro')
% crtamo vrednosti na funkciji u krajevima intervala
plot([a b], [feval(f,a) feval(f,b)], 'ro')

% sve dok nam je interval siri od trazene tacnosti
while abs(b - a) >= eps
    
    % pronalazimo centralnu tacku intervala
    m = (a + b)/2;
    % ispitujemo sredisnju tacku kao granicu novog uzeg intervala
    % i azuriramo granice na odgovarajuci nacin
    if feval(f, a) * feval(f, m) <= 0
        b = m;
    else
        a = m;
    end
    
    % crtamo nove granice na  grafiku
    plot([a b], [0 0], 'bo')
    % crtamo vrednosti funkcije na krajevima novog intervala
    plot([a b], [feval(f,a) feval(f,b)], 'bo')
    % postavljamo naslov grafik 
    title(['x =' num2str(m)])
    
    % pauziramo izvrsavanje na 0.1 sekundu 
    pause(0.1)
end

% stampamo pronadjenu nulu
disp('Nula funkcije je')
disp((b + a)/2);

hold off
