% inline - zastarelo resenje, bice izbaceno u novim verzijama matlaba
%f = inline('x.^3-x');
% anonimna funkcija
f = @(x) x.^3 - x;
% definisemo granice intervala
a = -7;
b = 0;
% definisemo fiksnu tacku
xF = -7;

% naivno biramo pocetnu tacku
x0 = 6;
% definisemo tacnost
eps = 1e-3;

% pravimo podelu intervala
t = linspace(a, b, 1000);
% izracunvamo funkciju u tackama podele
ft = feval(f, t);

% crtamo grafik
figure(1)
clf
hold on
% grafik funkcije
plot(t, ft, 'g');
% x osa
plot([a b], [0 0], 'k');

% prvo resenje nam je pocetna tacka
x = x0;
% racunamo vrednost funkcije u tacki x0
y = feval(f, x0);
% racunamo vrednost funkcije u tacki xF
yF = feval(f, xF);

% u petlji trazimo nulu
while (1)
   
   % pamtimo trenutna resenja
   xp = x;
   yp = y;
   
   % proveravamo da li postoji secica
   if (yF == yp)
      error('Secica nema presek sa x osom');
   end
   
   % po formuli racunamo novu vrednost x
   x = xp - xp/(yF - yp)*(xF - xp);
   % racunamo y za novu iteraciju
   y = feval(f, x);
   
   % prikazujemo tacke prethodnog resenja na grafiku
   plot(xp, yp, 'o');
   % ucrtavamo novo resenje na x osi
   plot(x, 0, 'o');
   
   % crtamo duz koja spaja fikcnu tacku i novo resenje
   plot([xF x], [yF 0], 'r');
   % crtamo duz koja spaja staro resenje i novo resenje
   plot([xp x], [yp 0], 'r');
   
   % postavljamo naslov graifka
   title(['x=' num2str(x, 16)]);
   % pauziramo izvrsavanje na 100ms
   pause(0.1)
   
   % ako smo postigli dovoljnu tacnost, prekidamo izvrsavanje
   if (abs(xp - x) < eps)
       break;
   end
end
