% donja granica intervala
a = -5;
% gornja granica intervala
b = 5;
% korak u podeli
k = 0.5
% kreiramo podelu intervala
x1 = (a:k:b);
% saznamo broj elemenata u podeli
n = numel(x1);
% prazni vektori
x2 = [];	% vektori za cebisevljeve cvorove
y1 = []		% vrednost funkcije u ekvidistantnoj podeli
y2 = [];	% vrednosti funkcije u cebisevljevoj podeli
% u petlji
for (i = 1:1:n)
	% racunamo cebisevljeve cvorove
   x2(i) = (a+b)/2 + (b-a)/2*cos((n-i+0.5)/n*pi);
   % racunamo vrednosti funkcije
   y1(i) = 1/(1+25*x1(i)^2);
   y2(i) = 1/(1 + 25*x2(i)^2);
end

% izracunavamo polinom stepena 2 koji aproksimira funkciju
p1 = polyfit(x1, y1, 2);
% izracunavamo polinom stepena 3 koji aproksimira funkciju
p2 = polyfit(x2, y2, 2);
% izracunavamo splajn u tackama ekvidistantne podele
p1s = spline(x1, y1);
% izracunavamo splajn u tackama cebisevljeve podele
p2s = spline(x2, y2);

% pravimo novu finiju podelu
x = (a:0.01:b);
% vektor vrednosti funkcije
y = [];
% u petlji racunamo vrednost funkcije za tacke podele x
for (i = 1:1:numel(x))
   y(i) = 1/(1 + 25*x(i)^2); 
end

% graficki prikazujemo dobijene rezultate
% splajn se izracunava pomocu tacke ppval
figure(1)
plot(x, y, x1, polyval(p1, x1), x2, polyval(p2, x2), x1, ppval(p1s, x1), x2, ppval(p2s, x2));
legend('Prava fja', 'Ekvidistantni pol2', 'Cebisevljev pol2', 'Ekvidistantni splajn', 'Cebisevljev splajn');
grid