function zad2( n )

% kreiramo vektore x1 i x2 kao nula vektore dimenzije n
x1 = zeros(n, 1);
x2 = zeros(n, 1);

% u petlji, popunjavamo vektorore po zadataom pravilu
for i = 1:n
    % elementi vektora x1 su slucajno brojevi iz intervala [i,2*i]
   x1(i) = i + (2*i - i)*rand(); 
   % proveramo parnost brojaca
   if (mod(i,2) == 0)
       % na parna mesta postavljamo vrednosti funkcije sinus
       x2(i) = sin(i);
   else
       % na neparna mesta postavljamo vrednosti funkcije kosinus
       x2(i) = cos(i);
   end
end

% kreiramo vektor x kao nula vektor dimenzije n*n
x = zeros(1, n*n);
% pravimo dekartov proizvod
for i = 1:n
    for j = 1:n
        % elemente vektora e racunamo kao "svaki sa svakim" zbirove elemenata 
        % vektora x1 i x2 
        x(i*n + j) = x1(i) + x2(j); 
    end
end

% alternativno, vektor x moze da se indeksira i pomocnom promenljivom k
% k = 1;
% % pravimo dekartov proizvod
% for i = 1:n
%     for j = 1:n
%         % elemente vektora e racunamo kao "svaki sa svakim" zbirove elemenata 
%         % vektora x1 i x2 
%         x(k) = x1(i) + x2(j); 
%         % neophodno je uvecati pomocni brojac i preci na novu poziciju
%         k = k+1;
%     end
% end

% kreiramo zadatu funkciju
f = @(x) x.^2 - 8.*x + 1./x;
% racunamo vrednosti funkciju u tackama vektora x
fx = feval(f, x);

% crtamo grafik za zadatim svojstvima
figure(1)
% zeleni krugovi - go
plot(x, fx, 'go');
% naslov grafika
title('y = f(x)')
% obelezje x ose
xlabel('x osa')
% obelezje y ose
ylabel('y osa')
% legenda
legend('x^2 - 8x + 1/x')
% mreza
grid

end

